import * as React from 'react';

interface WsReactBaseModalAction {
    isDefaultCancel?: boolean;
    isDefault?: boolean;
    isDisabled?: boolean | (() => any);
    onClick?: () => any;
    title?: string;
}

interface WsReactBaseModalProps {
    show?: boolean;
    currentWidth?: number;
    currentHeight?: number;
    title?: string;
    titleCustom?: any;
    hideTitle?: boolean;
    closeCallback?: () => any;
    closeOnBackClick?: boolean;
    actions?: WsReactBaseModalAction[];
    parentClass?: string;
    fullScreen?: boolean;
}

export interface IModalStoreShowActionParams extends WsReactBaseModalAction {
    notCloseModal?: boolean;
}

export interface IModalStoreShowParams extends WsReactBaseModalProps {
    actions?: IModalStoreShowActionParams[];
    content?: (closeCallback: () => any) => false | JSX.Element;
}

export interface IModalStoreParams {
    index: number;
    params: IModalStoreShowParams;
}

export class WsReactBaseModal extends React.Component<WsReactBaseModalProps, any> {}

declare class ModalStore {
    modalParams: IModalStoreParams[];
    showModal: (params: IModalStoreShowParams) => number;
    closeModal: (index: number) => any;
}
declare const modalStore: ModalStore;

interface IModalStoreViewProps {
    modalStore?: ModalStore;
}

declare class ModalStoreView extends React.Component<IModalStoreViewProps, any> {
}

export {
    modalStore, ModalStore, ModalStoreView,
};
